Subject: Re: [5.6.0-rc2-next-20200218/powerpc] Boot failure on POWER9

From: Michal Hocko <[email-masked]>
Date: Tue, 18 Feb 2020 16:24:41 +0100

On Tue 18-02-20 20:41:12, Sachin Sant wrote:
> 
> >> Yes, I can recreate the same problem with the patch applied on top of
> >> 5.6.0-rc2. 
> > 
> > And just to make sure. This was with http://lkml.kernel.org/r/[email-masked]
> > right?
> > 
> Yes, the same patch.
> 
> > If yes, is it possible that the specific node is somehow crippled (e.g.
> > some nodes don't have any memory and thus the allocator blows up)? In
> > other words what is the numa topology? (numactl -H)
> > 
> 
> Here is the o/p of numactl
> 
> # numactl -H
> available: 2 nodes (0-1)
> node 0 cpus:
> node 0 size: 0 MB
> node 0 free: 0 MB

OK, so what I expected. The node0 is memory less or simply not present
at all. Fun!

Anyway, I do not think it is expected that kmalloc_node just blows up
on those nodes. The page allocator simply falls back to the closest
node. Something for kmalloc maintainers I believe.

A short summary. kmalloc_node blows up when trying to allocate from a
memory less node.

> node 1 cpus: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31
> node 1 size: 35247 MB
> node 1 free: 30907 MB
> node distances:
> node   0   1 
>   0:  10  40 
>   1:  40  10 
> # 
> 
> Thanks
> -Sachin

-- 
Michal Hocko
SUSE Labs